#ifndef GARBAGE_COLLECTOR_H
#define GARBAGE_COLLECTOR_H

#include <stdlib.h>

struct gc_list {
	void *elem;
	struct gc_list *next;
};

#define GC_ITER(LIST_NAME) _iter_##LIST_NAME

#define MAKE_GC(NAME) \
static struct gc_list NAME = { NULL, NULL }; \
static struct gc_list *GC_ITER(NAME) = &NAME; \
static void _throw_away_##NAME() { \
	struct gc_list *l; \
	GC_ITER(NAME) = &NAME; \
	l = GC_ITER(NAME)->next; \
	while ((GC_ITER(NAME) = l) != NULL) { \
		l = GC_ITER(NAME)->next; \
		free(GC_ITER(NAME)->elem); \
		free(GC_ITER(NAME)); \
	} \
}

#define GC_ALLOC(TYPE, TARGET, LEN, GC_NAME) \
do { \
	GC_ITER(GC_NAME) = GC_ITER(GC_NAME)->next = (struct gc_list *)malloc(sizeof(struct gc_list)); \
	GC_ITER(GC_NAME)->elem = TARGET = (TYPE *)malloc((LEN) * sizeof(TYPE)); \
	GC_ITER(GC_NAME)->next = NULL; \
} while (0)

#define GC_FREE(NAME) _throw_away_##NAME()

#endif